#
# vim:set syntax=python:

import java 
import sys
import time
import re
from IAG.control import *

lineSeparator = java.lang.System.getProperty('line.separator') 

#     #
#    # #     ####    #####     #    #    #    ##     #####     #     ####   #    #
#   #   #   #    #     #       #    #    #   #  #      #       #    #    #  ##   #
#  #     #  #          #       #    #    #  #    #     #       #    #    #  # #  #
#  #######  #          #       #    #    #  ######     #       #    #    #  #  # #
#  #     #  #    #     #       #     #  #   #    #     #       #    #    #  #   ##
#  #     #   ####      #       #      ##    #    #     #       #     ####   #    #
# 
#  #####
# #     #  #####   ######   ####
# #        #    #  #       #    #
#  #####   #    #  #####   #
#       #  #####   #       #
# #     #  #       #       #    #
#  #####   #       ######   ####
# 

#-----------------------------------------------------------------------------------------------
#
#  LIST Activation Specs
#
#  Get list of Activation Specs to Monitor along with std properties
#
#-----------------------------------------------------------------------------------------------

def list(cfg, server):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	list = []
	
	print '** Loading Activation Specs **'
	
	#for asID in AdminConfig.list( 'J2CActivationSpec', server[ 'ID' ] ).splitlines():
		
	for asID in AdminControl.queryNames('type=J2CMessageEndpoint,' + 'Server=' + server['name'] + ',*').splitlines():
	
	        if len(asID) > 0:
	
	           props=asID.split(',')
	        
	           prophash = {}
	           for p in props:
	               px = p.split('=')	            
	               prophash[px[0]] = px[1]
	            	            			
		   list.append(                                      \
		               {'name':prophash['ActivationSpec'],   \
		                'ID':asID,                           \
		                'cell':prophash['cell'],             \
		                'node':prophash['node'],             \
		                'server':prophash['Server']          \
		               }                                     \
		              )
		             
	server[ 'activationspecs' ] = list
	return '1'

 
#-----------------------------------------------------------------------------------------------
#
#  TEST Activation Specs
#
#  Test current Status of Activation Specs
#
#-----------------------------------------------------------------------------------------------
def test(cfg, as): 
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Cant Load the wsadmin Modules"


	curTime = time.time()

	if iterationTime( cfg, as, cfg.listenerIterationTime ) == None:
		return None

	try:
		okState = AdminControl.invoke( as[ 'ID' ], 'getStatus' )
		as[ 'lastStatus' ] = { 'bool': '0', 'curState': okState, 'time': curTime }
		dateIteration( cfg, as )
		return '1'

	except:
                print 'EXCEPTION getting Activation Spec state'
		as[ 'lastStatus' ] = { 'bool': '1', 'curState': '0', 'time': curTime }
		dateIteration( cfg, as )
		return '1'
