#
# vim:set syntax=python:

import java 
import sys
import time
import re
from IAG.control import *

lineSeparator = java.lang.System.getProperty('line.separator') 

#  
#  #     #
#  ##   ##  ######   ####    ####     ##     ####      #    #    #   ####
#  # # # #  #       #       #        #  #   #    #     #    ##   #  #    #
#  #  #  #  #####    ####    ####   #    #  #          #    # #  #  #
#  #     #  #            #       #  ######  #  ###     #    #  # #  #  ###
#  #     #  #       #    #  #    #  #    #  #    #     #    #   ##  #    #
#  #     #  ######   ####    ####   #    #   ####      #    #    #   ####
#  
#  ######  #    #   ####      #    #    #  ######
#  #       ##   #  #    #     #    ##   #  #
#  #####   # #  #  #          #    # #  #  #####
#  #       #  # #  #  ###     #    #  # #  #
#  #       #   ##  #    #     #    #   ##  #
#  ######  #    #   ####      #    #    #  ######
#

#-----------------------------------------------------------------------------------------------
#
#  LIST Messaging Engines
#
#  Get list of Messaging Engines to monitor with std properties
#
#-----------------------------------------------------------------------------------------------

def list(cfg):

    try:
	AdminConfig  = cfg.AdminConfig
	AdminControl = cfg.AdminControl
	AdminApp     = cfg.AdminApp
	AdminTask    = cfg.AdminTask
    except: 
	print "Can Load the wsadmin Modules"

    print '*** Loading Messaging Engines ***'

    list = []

    try:
       mes = AdminConfig.list("SIBMessagingEngine").split("\n")
       print mes
       print len(mes)

       for me in mes:

          print "ME " + me
          # Remove carriage returns on Windows
          me = me.strip()

          if len(me) > 0:
             # Construct an ME object
             meBus  = AdminConfig.showAttribute(me, "busName")
             meName = AdminConfig.showAttribute(me, "name")
             meUUID = AdminConfig.showAttribute(me, "uuid")
             meLookupName = AdminControl.makeObjectName('WebSphere:type=SIBMessagingEngine,name=' + meName + ',*')
             qpLookupNames = AdminControl.queryNames('WebSphere:type=SIBQueuePoint,SIBMessagingEngine=' + meName + ',*')
             qpList = qpLookupNames.splitlines()

             meattrs = {'name':meName, 'IDcfg':me, 'IDmbean':meLookupName,
                        'bus':meBus, 'uuid':meUUID, 'qps':qpList }

             list.append( meattrs )

    except Exception, data:
        print "EXCEPTIOJN LOADING MESSAGING ENGINES"
        print Exception
        print data
		             
    cfg.messagingengines = list
    return '1'

 
#-----------------------------------------------------------------------------------------------
#
#  TEST Messaging Engines
#
#  Test current Status of Messaging Engines
#
#-----------------------------------------------------------------------------------------------
def test(cfg, me, i): 
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"


	curTime = time.time()

	if iterationTime( cfg, me, cfg.listenerIterationTime ) == None:
		return None

	try:
            meLookupName = me['IDmbean']
            meMBeans     = AdminControl.queryNames_jmx(meLookupName, None)
      
            meStatetxt='????'
            meState='4'
            meServer='????'
            meMBean = None

            if (meMBeans == None) or (meMBeans.size() == 0):
                # Just an empty messaging engine
                meStatetxt      = 'NotFound'
                meState         = '2'

            elif meMBeans.size() == 1:
                meMBean = meMBeans[0]
                meStatetxt  = 'Started'
                meState     = '1'
                meServer = meMBean.getKeyProperty("process")

            else:
                meStatetxt  = 'TooMany'
                meState     = '3'

            i.metric( "IntCounter", [ 'SIBus', me['bus'], me['name'], 'state' ], meState )
            i.metric( "StringEvent", [ 'SIBus', me['bus'], me['name'], 'statetxt' ], meState )
            i.metric( "StringEvent", [ 'SIBus', me['bus'], me['name'], 'server' ], meServer )

            if meMBean != None:

              for qpMBean in me['qps']:
 
                attrs  = AdminControl.getAttributes(qpMBean)
                attrlist1 = attrs[1:-1].split('] ')

                attrhash = {}
                for a in attrlist1:
                    if len(a) > 2:
                       parms=a[1:].split(' ')
                       attrhash[parms[0]] = parms[1]

                qpName  = attrhash["identifier"]
                if attrhash['state'] == 'ACTIVE':
                    qpState = '1'
                else:
                    qpState = '2'

                if attrhash['sendAllowed'] == 'true':
                    qpSend = '1'
                else:
                    qpSend = '0'

		i.metric( "IntCounter", [ 'SIBus', me['bus'], me['name'], 'QueuePoint', qpName, 'state' ], qpState )
		i.metric( "StringEvent", [ 'SIBus', me['bus'], me['name'], 'QueuePoint', qpName, 'statetxt' ],  attrhash['state'] )
		i.metric( "IntCounter", [ 'SIBus', me['bus'], me['name'], 'QueuePoint', qpName, 'send' ], qpSend )
		i.metric( "IntCounter", [ 'SIBus', me['bus'], me['name'], 'QueuePoint', qpName, 'depth' ], attrhash['depth'] )
		i.metric( "IntCounter", [ 'SIBus', me['bus'], me['name'], 'QueuePoint', qpName, 'max' ], attrhash['highMessageThreshold'] )

	    me[ 'lastStatus' ] = { 'bool': '0', 'time': curTime }
	    dateIteration( cfg, me )
	    return '1'

	except Exception, data:
            print 'EXCEPTION getting ME state'
            print Exception
            print data
	    me[ 'lastStatus' ] = { 'bool': '1', 'time': curTime }
	    dateIteration( cfg, me )
	    return '1'
