#
# vim:set syntax=python:
#import os

import java 
import sys
import time
import re
from IAG.control import *

lineSeparator = java.lang.System.getProperty('line.separator') 

# ~                                                                       ~~~~~~                                  
# ~           ~     ~~~~    ~~~~~  ~~~~~~  ~    ~  ~~~~~~  ~~~~~          ~     ~   ~~~~   ~~~~~    ~~~~~   ~~~~  
# ~           ~    ~          ~    ~       ~~   ~  ~       ~    ~         ~     ~  ~    ~  ~    ~     ~    ~      
# ~           ~     ~~~~      ~    ~~~~~   ~ ~  ~  ~~~~~   ~    ~         ~~~~~~   ~    ~  ~    ~     ~     ~~~~  
# ~           ~         ~     ~    ~       ~  ~ ~  ~       ~~~~~          ~        ~    ~  ~~~~~      ~         ~ 
# ~           ~    ~    ~     ~    ~       ~   ~~  ~       ~   ~          ~        ~    ~  ~   ~      ~    ~    ~ 
# ~~~~~~~     ~     ~~~~      ~    ~~~~~~  ~    ~  ~~~~~~  ~    ~         ~         ~~~~   ~    ~     ~     ~~~~  
#                                                                                                                 


def list(cfg, server):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

# 	global cfg 
	list = []
	for listenerID in AdminConfig.list( 'ListenerPort', server[ 'ID' ] ).splitlines():
		listenerNm  = AdminConfig.showAttribute( listenerID, 'name')
		maxRetries  = AdminConfig.showAttribute( listenerID, 'maxRetries')
		smgmt       = AdminConfig.showAttribute( listenerID, 'stateManagement')
		state       = AdminConfig.showAttribute( smgmt, 'initialState')
		try:
			listenerObj = AdminConfig.getObjectName( listenerID )
		except:
			listenerObj = ''
		list.append({'name':listenerNm,         'ID':listenerID,         \
		             'objectNm':listenerObj,    'maxRetries':maxRetries, \
								 'initialState':state})
	server[ 'listeners' ] = list
	return '1'

 
def test(cfg, listener): 
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	# Tests a single DataSource, outputType can be --
	# 
	# Tests (and response code)--
	#   wsadmin>AdminControl.getAttribute('WebSphere:name=wrm_sendremovequoteestimate_listener,process=SysOrmTendering2M2,platform=proxy,node=uaswas11N3,version=7.0.0.7,type=ListenerPort,mbeanIdentifier=cells/SysOrmCell/nodes/uaswas11N3/servers/SysOrmTendering2M2/server.xml#ListenerPort_1268095530135,cell=SysOrmCell,spec=1.0', 'started')
	#   'true'
	# define the iterator and/or check if it is time to check yet
	curTime = time.time()

	if iterationTime( cfg, listener, cfg.listenerIterationTime ) == None:
		return None

# 	if not listener.has_key("objectNm") or (listener.has_key("objectNm") and listener[ 'objectNm' ] == ''): 
# 		try: 
# 			listener[ 'objectNm' ] = AdminConfig.getObjectName( listener[ 'ID' ] ) 
# 		except: 
# 			listener[ 'objectNm' ] = '' 
#  
# 			listener[ 'lastStatus' ] = { 'bool': '0', 'msg': 'Stopped. Cold not complete object name', 'time': curTime } 
# 			dateIteration( cfg, listener ) 
# 			return '1' 

	try:

		result = AdminControl.getAttribute( listener[ 'objectNm' ], 'started' )
		if result == 'true':
			if listener[ 'initialState' ] == 'START':
				okState = '1'
			else:
				okState = '0'
			listener[ 'lastStatus' ] = { 'bool': '1', 'curState': okState, 'msg': 'Started', 'time': curTime }
		else: 
			if listener[ 'initialState' ] == 'STOP':
				okState = '1'
			else:
				okState = '0'
			listener[ 'lastStatus' ] = { 'bool': '0', 'curState': okState, 'msg': 'Stopped', 'time': curTime }
		dateIteration( cfg, listener )
		return '1'
	except:
		listener[ 'lastStatus' ] = { 'bool': '0', 'msg': 'UnknownStatus', 'time': curTime }
		dateIteration( cfg, listener )
		return '1'
